import 'dart:async';

import 'package:flutter/widgets.dart';

import '../mvc.dart';
import 'Model.dart';

// ignore: must_be_immutable
abstract class Controller<V extends View, M extends Model>
    extends StatefulWidget {
  // ignore: close_sinks
  StreamController<Event> _streamController;
  V view;
  M model;
  BuildContext context;

  void create(View view, Model model) {
    _streamController = StreamController();
    this.model = model;
    this.view = view;
    view.addNotifier(_streamController);

    _streamController.stream.listen(eventHandler);
  }

  void eventHandler(Event event);
}

abstract class ControllerState<ExtendedController extends Controller>
    extends State<ExtendedController> {
  @override
  Widget build(BuildContext context) {
    return widget.view.viewWidget;
  }

  @override
  void initState() {
    super.initState();

    widget.context = context;
  }

  @override
  void didUpdateWidget(ExtendedController oldWidget) {
    super.didUpdateWidget(oldWidget);

    widget.context = oldWidget.context;
  }

  @override
  void dispose() {
    widget._streamController.close();
    widget.context = null;

    super.dispose();
  }
}
