import 'dart:async';

import 'package:flutter/widgets.dart';

import '../mvc.dart';

// ignore: must_be_immutable
abstract class StatefulView extends StatefulWidget with View {
  StatefulView() {
    this.viewWidget = this;
  }
}

// ignore: must_be_immutable
abstract class StatelessView extends StatelessWidget with View {
  StatelessView() {
    this.viewWidget = this;
  }
}

abstract class View {
  Widget viewWidget;
  StreamController controllerNotifier;

  void addNotifier(StreamController notifier) {
    this.controllerNotifier = notifier;
  }

  void notifyController(Event event) {
    controllerNotifier.add(event);
  }
}
